---
title: 'Example and tutorial: Simple synth keyboard'
slug: Web/API/Web_Audio_API/Simple_synth
tags:
  - Audio
  - Example
  - Guide
  - Media
  - Oscillator
  - Piano
  - Synthesizer
  - Tutorial
  - Web Audio API
---
<div>{{DefaultAPISidebar("Web Audio API")}}</div>

<p>This article presents the code and working demo of a video keyboard you can play using the mouse. The keyboard allows you to switch among the standard waveforms as well as one custom waveform, and you can control the master gain using a volume slider beneath the keyboard. This example makes use of the following Web API interfaces: {{domxref("AudioContext")}}, {{domxref("OscillatorNode")}}, {{domxref("PeriodicWave")}}, and {{domxref("GainNode")}}.</p>

<p>Because {{domxref("OscillatorNode")}} is based on {{domxref("AudioScheduledSourceNode")}}, this is to some extent an example for that as well.</p>

<h2 id="The_video_keyboard">The video keyboard</h2>

<h3 id="HTML">HTML</h3>

<p>There are three primary components to the display for our virtual keyboard. The first is the musical keyboard itself. We draw this in a pair of nested {{HTMLElement("div")}} elements so that we can make the keyboard horizontally scrollable if all the keys don't fit on the screen, without having them wrap around.</p>

<h4 id="The_keyboard">The keyboard</h4>

<p>First, we create space to build the keyboard into. We will be programmatically constructing the keyboard, because doing so gives us the flexibility to configure each key as we determine the appropriate data for the corresponding note. In our case, we get each key's frequency from a table, but it could be calculated algorithmically as well.</p>

<pre class="brush: html notranslate">&lt;div class="container"&gt;
  &lt;div class="keyboard"&gt;&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>The {{HTMLElement("div")}} named <code>"container"</code> is the scrollable box that lets the keyboard be scrolled horiontally if it's too wide for the available space. The keys themselves will be inserted into the block of class <code>"keyboard"</code>.</p>

<h4 id="The_settings_bar">The settings bar</h4>

<p>Beneath the keyboard, we'll put some controls for configuring the layer. For now, we will have two controls: one to set the master volume and another to select what periodic waveform to use when generating notes.</p>

<h5 id="The_volume_control">The volume control</h5>

<p>First we create the <code>&lt;div&gt;</code> to contain the settings bar, so it can be styled as needed. Then we establish a box that will be presented on the left side of the bar and place a label and an {{HTMLElement("input")}} element of type <code>"range"</code>. The range element will typically be presented as a slider control; we configure it to allow any value between 0.0 and 1.0, stepping by 0.01 each position.</p>

<pre class="brush: html notranslate">&lt;div class="settingsBar"&gt;
  &lt;div class="left"&gt;
    &lt;span&gt;Volume: &lt;/span&gt;
    &lt;input type="range" min="0.0" max="1.0" step="0.01"
        value="0.5" list="volumes" name="volume"&gt;
    &lt;datalist id="volumes"&gt;
      &lt;option value="0.0" label="Mute"&gt;
      &lt;option value="1.0" label="100%"&gt;
    &lt;/datalist&gt;
  &lt;/div&gt;
</pre>

<p>We specify a default value of 0.5, and we provide a {{HTMLElement("datalist")}} element which is connected to the range using the {{htmlattrxref("name")}} attribute to find an option list whose ID matches; in this case, the data set is named <code>"volume"</code>. This lets us provide a set of common values and special strings which the browser may optionally choose to display in some fashion; we provide names for the values 0.0 ("Mute") and 1.0 ("100%").</p>

<h5 id="The_waveform_picker">The waveform picker</h5>

<p>On the right side of the settings bar, we place a label and a {{HTMLElement("select")}} element named <code>"waveform"</code> whose options correspond to the available waveforms.</p>

<pre class="brush: html notranslate">  &lt;div class="right"&gt;
    &lt;span&gt;Current waveform: &lt;/span&gt;
    &lt;select name="waveform"&gt;
      &lt;option value="sine"&gt;Sine&lt;/option&gt;
      &lt;option value="square" selected&gt;Square&lt;/option&gt;
      &lt;option value="sawtooth"&gt;Sawtooth&lt;/option&gt;
      &lt;option value="triangle"&gt;Triangle&lt;/option&gt;
      &lt;option value="custom"&gt;Custom&lt;/option&gt;
    &lt;/select&gt;
  &lt;/div&gt;
&lt;/div&gt;</pre>

<div class="hidden">
<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">.container {
  overflow-x: scroll;
  overflow-y: hidden;
  width: 660px;
  height: 110px;
  white-space: nowrap;
  margin: 10px;
}

.keyboard {
  width: auto;
  padding: 0;
  margin: 0;
}

.key {
  cursor: pointer;
  font: 16px "Open Sans", "Lucida Grande", "Arial", sans-serif;
  border: 1px solid black;
  border-radius: 5px;
  width: 20px;
  height: 80px;
  text-align: center;
  box-shadow: 2px 2px darkgray;
  display: inline-block;
  position: relative;
  margin-right: 3px;
  user-select: none;
  -moz-user-select: none;
  -webkit-user-select: none;
  -ms-user-select: none;
}

.key div {
  position: absolute;
  bottom: 0;
  text-align: center;
  width: 100%;
  pointer-events: none;
}

.key div sub {
  font-size: 10px;
  pointer-events: none;
}

.key:hover {
  background-color: #eef;
}

.key:active {
  background-color: #000;
  color: #fff;
}

.octave {
  display: inline-block;
  padding: 0 6px 0 0;
}

.settingsBar {
  padding-top: 8px;
  font: 14px "Open Sans", "Lucida Grande", "Arial", sans-serif;
  position: relative;
  vertical-align: middle;
  width: 100%;
  height: 30px;
}

.left {
  width: 50%;
  position: absolute;
  left: 0;
  display: table-cell;
  vertical-align: middle;
}

.left span, .left input {
  vertical-align: middle;
}

.right {
  width: 50%;
  position: absolute;
  right: 0;
  display: table-cell;
  vertical-align: middle;
}

.right span {
  vertical-align: middle;
}

.right input {
  vertical-align: baseline;
}</pre>
</div>

<h3 id="JavaScript">JavaScript</h3>

<p>The JavaScript code begins by initializing a number of variables.</p>

<pre class="brush: js notranslate">let audioContext = new (window.AudioContext || window.webkitAudioContext)();
let oscList = [];
let masterGainNode = null;
</pre>

<ol>
 <li><code>audioContext</code> is set to reference the global {{domxref("AudioContext")}} object (or <code>webkitAudioContext</code> if necessary).</li>
 <li><code>oscillators</code> is set up to be ready to contain a list of all currently-playing oscillators. It starts off empty, since there are none playing yet.</li>
 <li><code>masterGainNode</code> is set to null; during the setup process, it will be configured to contain a {{domxref("GainNode")}} which all playing oscillators will connect to and play through to allow the overall volume to be controlled using a single slider control.</li>
</ol>

<pre class="brush: js notranslate">let keyboard = document.querySelector(".keyboard");
let wavePicker = document.querySelector("select[name='waveform']");
let volumeControl = document.querySelector("input[name='volume']");
</pre>

<p>References to elements we'll need access to are obtained:</p>

<ul>
 <li><code>keyboard</code> is the container element into which the keys will be placed.</li>
 <li><code>wavePicker</code> is the {{HTMLElement("select")}} element used to choose the waveform to use for the notes.</li>
 <li><code>volumeControl</code> is the {{HTMLElement("input")}} element (of type <code>"range"</code>) used to control the master audio volume.</li>
</ul>

<pre class="brush: js notranslate">let noteFreq = null;
let customWaveform = null;
let sineTerms = null;
let cosineTerms = null;
</pre>

<p>Finally, global variables that will be used when constructing waveforms are created:</p>

<ul>
 <li><code>noteFreq</code> will be an array of arrays; each array represents one octave, each of which contains one entry for each note in that octave. The value for each is the frequency, in Hertz, of the note's tone.</li>
 <li><code>customWaveform</code> will be set up as a {{domxref("PeriodicWave")}} describing the waveform to use when the user selects "Custom" from the waveform picker.</li>
 <li><code>sineTerms</code> and <code>cosineTerms</code> will be used to store the data for generating the waveform; each will contain an array that's generated when the user chooses "Custom".</li>
</ul>

<h3 id="Creating_the_note_table">Creating the note table</h3>

<p>The <code>createNoteTable()</code> function builds the array <code>noteFreq</code> to contain an array of objects representing each octave. Each octave, in turn, has one named property for each note in that octave; the property's name is the note's name (such as "C#" to represent C-sharp), and the value is the frequency, in Hertz, of that note.</p>

<pre class="brush: js notranslate">function createNoteTable() {
  let noteFreq = [];
  for (let i=0; i&lt; 9; i++) {
    noteFreq[i] = [];
  }

  noteFreq[0]["A"] = 27.500000000000000;
  noteFreq[0]["A#"] = 29.135235094880619;
  noteFreq[0]["B"] = 30.867706328507756;

  noteFreq[1]["C"] = 32.703195662574829;
  noteFreq[1]["C#"] = 34.647828872109012;
  noteFreq[1]["D"] = 36.708095989675945;
  noteFreq[1]["D#"] = 38.890872965260113;
  noteFreq[1]["E"] = 41.203444614108741;
  noteFreq[1]["F"] = 43.653528929125485;
  noteFreq[1]["F#"] = 46.249302838954299;
  noteFreq[1]["G"] = 48.999429497718661;
  noteFreq[1]["G#"] = 51.913087197493142;
  noteFreq[1]["A"] = 55.000000000000000;
  noteFreq[1]["A#"] = 58.270470189761239;
  noteFreq[1]["B"] = 61.735412657015513;
</pre>

<p>... several octaves not shown for brevity ...</p>

<div class="hidden">
<pre class="brush: js notranslate">  noteFreq[2]["C"] = 65.406391325149658;
  noteFreq[2]["C#"] = 69.295657744218024;
  noteFreq[2]["D"] = 73.416191979351890;
  noteFreq[2]["D#"] = 77.781745930520227;
  noteFreq[2]["E"] = 82.406889228217482;
  noteFreq[2]["F"] = 87.307057858250971;
  noteFreq[2]["F#"] = 92.498605677908599;
  noteFreq[2]["G"] = 97.998858995437323;
  noteFreq[2]["G#"] = 103.826174394986284;
  noteFreq[2]["A"] = 110.000000000000000;
  noteFreq[2]["A#"] = 116.540940379522479;
  noteFreq[2]["B"] = 123.470825314031027;

  noteFreq[3]["C"] = 130.812782650299317;
  noteFreq[3]["C#"] = 138.591315488436048;
  noteFreq[3]["D"] = 146.832383958703780;
  noteFreq[3]["D#"] = 155.563491861040455;
  noteFreq[3]["E"] = 164.813778456434964;
  noteFreq[3]["F"] = 174.614115716501942;
  noteFreq[3]["F#"] = 184.997211355817199;
  noteFreq[3]["G"] = 195.997717990874647;
  noteFreq[3]["G#"] = 207.652348789972569;
  noteFreq[3]["A"] = 220.000000000000000;
  noteFreq[3]["A#"] = 233.081880759044958;
  noteFreq[3]["B"] = 246.941650628062055;

  noteFreq[4]["C"] = 261.625565300598634;
  noteFreq[4]["C#"] = 277.182630976872096;
  noteFreq[4]["D"] = 293.664767917407560;
  noteFreq[4]["D#"] = 311.126983722080910;
  noteFreq[4]["E"] = 329.627556912869929;
  noteFreq[4]["F"] = 349.228231433003884;
  noteFreq[4]["F#"] = 369.994422711634398;
  noteFreq[4]["G"] = 391.995435981749294;
  noteFreq[4]["G#"] = 415.304697579945138;
  noteFreq[4]["A"] = 440.000000000000000;
  noteFreq[4]["A#"] = 466.163761518089916;
  noteFreq[4]["B"] = 493.883301256124111;

  noteFreq[5]["C"] = 523.251130601197269;
  noteFreq[5]["C#"] = 554.365261953744192;
  noteFreq[5]["D"] = 587.329535834815120;
  noteFreq[5]["D#"] = 622.253967444161821;
  noteFreq[5]["E"] = 659.255113825739859;
  noteFreq[5]["F"] = 698.456462866007768;
  noteFreq[5]["F#"] = 739.988845423268797;
  noteFreq[5]["G"] = 783.990871963498588;
  noteFreq[5]["G#"] = 830.609395159890277;
  noteFreq[5]["A"] = 880.000000000000000;
  noteFreq[5]["A#"] = 932.327523036179832;
  noteFreq[5]["B"] = 987.766602512248223;

  noteFreq[6]["C"] = 1046.502261202394538;
  noteFreq[6]["C#"] = 1108.730523907488384;
  noteFreq[6]["D"] = 1174.659071669630241;
  noteFreq[6]["D#"] = 1244.507934888323642;
  noteFreq[6]["E"] = 1318.510227651479718;
  noteFreq[6]["F"] = 1396.912925732015537;
  noteFreq[6]["F#"] = 1479.977690846537595;
  noteFreq[6]["G"] = 1567.981743926997176;
  noteFreq[6]["G#"] = 1661.218790319780554;
  noteFreq[6]["A"] = 1760.000000000000000;
  noteFreq[6]["A#"] = 1864.655046072359665;
  noteFreq[6]["B"] = 1975.533205024496447;
</pre>
</div>

<pre class="brush: js notranslate">  noteFreq[7]["C"] = 2093.004522404789077;
  noteFreq[7]["C#"] = 2217.461047814976769;
  noteFreq[7]["D"] = 2349.318143339260482;
  noteFreq[7]["D#"] = 2489.015869776647285;
  noteFreq[7]["E"] = 2637.020455302959437;
  noteFreq[7]["F"] = 2793.825851464031075;
  noteFreq[7]["F#"] = 2959.955381693075191;
  noteFreq[7]["G"] = 3135.963487853994352;
  noteFreq[7]["G#"] = 3322.437580639561108;
  noteFreq[7]["A"] = 3520.000000000000000;
  noteFreq[7]["A#"] = 3729.310092144719331;
  noteFreq[7]["B"] = 3951.066410048992894;

  noteFreq[8]["C"] = 4186.009044809578154;
  return noteFreq;
}
</pre>

<p>The result is an array, <code>noteFreq</code>, with an object for each octave. Each octave object has named properties in it where the property name is the name of the note (such as "C#" to represent C-sharp) and the property's value is the note's frequency in Hertz. In part, the resulting object looks like this:</p>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="row">Octave</th>
   <td colspan="8" rowspan="1">Notes</td>
   <td rowspan="1"></td>
   <td rowspan="1"></td>
   <td rowspan="1"></td>
   <td rowspan="1"></td>
  </tr>
  <tr>
   <th scope="row">0</th>
   <td>"A" ⇒ 27.5</td>
   <td>"A#" ⇒ 29.14</td>
   <td>"B" ⇒ 30.87</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <th scope="row">1</th>
   <td>"C" ⇒ 32.70</td>
   <td>"C#" ⇒ 34.65</td>
   <td>"D" ⇒ 36.71</td>
   <td>"D#" ⇒ 38.89</td>
   <td>"E" ⇒ 41.20</td>
   <td>"F" ⇒ 43.65</td>
   <td>"F#" ⇒ 46.25</td>
   <td>"G" ⇒ 49</td>
   <td>"G#" ⇒ 51.9</td>
   <td>"A" ⇒ 55</td>
   <td>"A#" ⇒ 58.27</td>
   <td>"B" ⇒ 61.74</td>
  </tr>
  <tr>
   <th scope="row">2</th>
   <td colspan="12" rowspan="1" style="text-align: center;">. . .</td>
  </tr>
 </tbody>
</table>

<p>With this table in place, we can find out the frequency for a given note in a particular octave quite easily. If we want the frequency for the note G# in octave 1, we use <code>noteFreq[1]["G#"]</code> and get the value 51.9 as a result.</p>

<div class="note">
<p>The values in the example table above have been rounded to two decimal places.</p>
</div>

<div class="hidden">
<p>This polyfill stands in when <code>Object.entries()</code> doesn't exist.</p>

<pre class="brush: js notranslate">if (!Object.entries) {
    Object.entries = function entries(O) {
        return reduce(keys(O), (e, k) =&gt; concat(e, typeof k === 'string' &amp;&amp; isEnumerable(O, k) ? [[k, O[k]]] : []), []);
    };
}
</pre>
</div>

<h3 id="Building_the_keyboard">Building the keyboard</h3>

<p>The <code>setup()</code> function is responsible for building the keyboard and preparing the app to play music.</p>

<pre class="brush: js notranslate">function setup() {
  noteFreq = createNoteTable();

  volumeControl.addEventListener("change", changeVolume, false);

  masterGainNode = audioContext.createGain();
  masterGainNode.connect(audioContext.destination);
  masterGainNode.gain.value = volumeControl.value;

  // Create the keys; skip any that are sharp or flat; for
  // our purposes we don't need them. Each octave is inserted
  // into a &lt;div&gt; of class "octave".

  noteFreq.forEach(function(keys, idx) {
    let keyList = Object.entries(keys);
    let octaveElem = document.createElement("div");
    octaveElem.className = "octave";

    keyList.forEach(function(key) {
      if (key[0].length == 1) {
        octaveElem.appendChild(createKey(key[0], idx, key[1]));
      }
    });

    keyboard.appendChild(octaveElem);
  });

  document.querySelector("div[data-note='B'][data-octave='5']").scrollIntoView(false);

  sineTerms = new Float32Array([0, 0, 1, 0, 1]);
  cosineTerms = new Float32Array(sineTerms.length);
  customWaveform = audioContext.createPeriodicWave(cosineTerms, sineTerms);

  for (i=0; i&lt;9; i++) {
      oscList[i] = {};
  }
}

setup();</pre>

<ol>
 <li>The table which maps note names and octaves to their frequenies is created by calling <code>createNoteTable()</code>.</li>
 <li>An event handler is established (by calling our old friend {{domxref("EventTarget.addEventListener", "addEventListener()")}} to handle {{event("change")}} events on the master gain control. This will update the master gain node's volume to the new value of the control.</li>
 <li>Next, we iterate over each octave in the note frequencies table. For each octave, we use {{jsxref("Object.entries()")}} to get a list of the notes in that octave.</li>
 <li>Create a {{HTMLElement("div")}} to contain that octave's notes (so we can have a small bit of space drawn between octaves), and set its class name to "octave"</li>
 <li>For each key in the octave, we check to see if the note's name has more than one character. We skip these, because we're leaving out the sharp notes in this example. If the note's name is only one character, then we call <code>createKey()</code>, specifying the note string, octave, and frequency. The returned element is appended to the octave element created  in step 4.</li>
 <li>When each octave element has been built, it's appended to the keyboard.</li>
 <li>Once the keyboard has been constructed, we scroll the note "B" in octave 5 into view; this has the effect of ensuring that middle-C is visible along with its surrounding keys.</li>
 <li>Then a new custom waveform is built using {{domxref("AudioContext.createPeriodicWave()")}}. This waveform will be used any time the user selects "Custom" from the waveform picker control.</li>
 <li>Finally, the oscillator list is initialized to ensure that it's ready to receive information identifiying which oscillators are associated with which keys.</li>
</ol>

<h4 id="Creating_a_key">Creating a key</h4>

<p>The <code>createKey()</code> function is called once for each key that we want to present in the virtual keyboard. It creates the elements that comprise the key and its label, adds some data attributes to the element for later use, and assigns event handlers for the events we care about.</p>

<pre class="brush: js notranslate">function createKey(note, octave, freq) {
  let keyElement = document.createElement("div");
  let labelElement = document.createElement("div");

  keyElement.className = "key";
  keyElement.dataset["octave"] = octave;
  keyElement.dataset["note"] = note;
  keyElement.dataset["frequency"] = freq;

  labelElement.innerHTML = note + "&lt;sub&gt;" + octave + "&lt;/sub&gt;";
  keyElement.appendChild(labelElement);

  keyElement.addEventListener("mousedown", notePressed, false);
  keyElement.addEventListener("mouseup", noteReleased, false);
  keyElement.addEventListener("mouseover", notePressed, false);
  keyElement.addEventListener("mouseleave", noteReleased, false);

  return keyElement;
}
</pre>

<p>After creating the elements that will represent the key and its label, we configure the key's element by setting its class to "key" (which establishes its appearance). Then we add {{htmlattrxref("data-*")}} attributes which contain the key's octave (attribute <code>data-octave</code>), string representing the note to play (attribute <code>data-note</code>), and frequency (attribute <code>data-frequency</code>) in Hertz. This will let us easily fetch that information as needed when handling events.</p>

<h3 id="Making_music">Making music</h3>

<h4 id="Playing_a_tone">Playing a tone</h4>

<p>The <code>playTone()</code> function's job is to play a tone at the given frequency. This will be used by the handler for events triggering keys on the keyboard to start playing the appropriate notes.</p>

<pre class="brush: js notranslate">function playTone(freq) {
  let osc = audioContext.createOscillator();
  osc.connect(masterGainNode);

  let type = wavePicker.options[wavePicker.selectedIndex].value;

  if (type == "custom") {
    osc.setPeriodicWave(customWaveform);
  } else {
    osc.type = type;
  }

  osc.frequency.value = freq;
  osc.start();

  return osc;
}
</pre>

<p><code>playTone()</code> begins by creating a new {{domxref("OscillatorNode")}} by calling the {{domxref("AudioContext.createOscillator()")}} method. We then connect it to the master gain node by calling the new oscillator's {{domxref("OscillatorNode.connect()")}} method;, which tells the oscillator where to send its output to. By doing this, changing the gain of the master gain node will affect the volume of all tones being generated.</p>

<p>Then we get the type of waveform to use by checking the value of the waveform picker control in the settings bar. If the user has it set to <code>"custom"</code>, we call {{domxref("OscillatorNode.setPeriodicWave()")}} to configure the oscillator to use our custom waveform. Doing this automatically sets the oscillator's {{domxref("OscillatorNode.type", "type")}} to <code>custom</code>. If any other waveform type is selected in the wave picker, we set the oscillator's type to the value of the picker; that value will be one of <code>sine</code>, <code>square</code>, <code>triangle</code>, and <code>sawtooth</code>.</p>

<p>The oscillator's frequency is set to the value specified in the <code>freq</code> parameter by setting the value of the {{domxref("Oscillator.frequency")}} {{domxref("AudioParam")}} object. Then, at last, the oscillator is started up so that it begins to produce sound by calling the oscillator's inherited {{domxref("AudioScheduledSourceNode.start()")}} method.</p>

<h4 id="Playing_a_tone_2">Playing a tone</h4>

<p>When the {{event("mousedown")}} or {{domxref("mouseover")}} event occurs on a key, we want to start playing the corresponding note. The <code>notePressed()</code> function is used as the event handler for these events.</p>

<pre class="brush: js notranslate">function notePressed(event) {
  if (event.buttons &amp; 1) {
    let dataset = event.target.dataset;

    if (!dataset["pressed"]) {
      let octave = +dataset["octave"];
      oscList[octave][dataset["note"]] = playTone(dataset["frequency"]);
      dataset["pressed"] = "yes";
    }
  }
}
</pre>

<p>We start by checking whether the primary mouse button is pressed, for two reasons. First, we want to only allow the primary mouse button to trigger notes playing. Second, and more importantly, we are using this to handle {{event("mouseover")}} for cases where the user is dragging from note to note, and we only want to start playing the note if the mouse is pressed when it enters the element.</p>

<p>If the mouse button is in fact down, we get the pressed key's {{htmlattrxref("dataset")}} attribute; this makes it easy to access the custom data attributes on the element. We look for a <code>data-pressed</code> attribute; if there isn't one (which indicates that the note isn't already playing), we call <code>playTone()</code> to start playing the note, passing in the value of the element's <code>data-frequency</code> attribute. The returned oscillator is stored into <code>oscList</code> for future reference, and <code>data-pressed</code> is set to <code>yes</code> to indicate that the note is playing so we don't start it again next time this is called.</p>

<h4 id="Stopping_a_tone">Stopping a tone</h4>

<p>The <code>noteReleased()</code> function is the event handler called when the user releases the mouse button or moves the mouse out of the key that's currently playing.</p>

<pre class="brush: js notranslate">function noteReleased(event) {
  let dataset = event.target.dataset;

  if (dataset &amp;&amp; dataset["pressed"]) {
    let octave = +dataset["octave"];
    oscList[octave][dataset["note"]].stop();
    delete oscList[octave][dataset["note"]];
    delete dataset["pressed"];
  }
}
</pre>

<p><code>noteReleased()</code> uses the <code>data-octave</code> and <code>data-note</code> custom attributes to look up the key's oscillator, then calls the oscillator's inherited {{domxref("AudioScheduledSourceNode.stop", "stop()")}} method to stop playing the note. Finally, the <code>oscList</code> entry for the note is cleared and the <code>data-pressed</code> attribute is removed from the key element (as identified by {{domxref("event.target")}}), to indicate that the note is not currently playing.</p>

<h4 id="Changing_the_master_volume">Changing the master volume</h4>

<p>The volume slider in the settings bar provides a simple interface to change the gain value on the master gain node, thereby changing the loudness of all playing notes. The <code>changeVolume()</code> method is the handler for the {{event("change")}} event on the slider.</p>

<pre class="brush: js notranslate">function changeVolume(event) {
  masterGainNode.gain.value = volumeControl.value
}
</pre>

<p>This sets the value of the master gain node's <code>gain</code> {{domxref("AudioParam")}} to the slider's new value.</p>

<h3 id="Result">Result</h3>

<p>Put all together, the result is a simple but working point-and-click musical keyboard:</p>

<p>{{ EmbedLiveSample('The_video_keyboard', 680, 200) }}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li>{{domxref("OscillatorNode")}}</li>
 <li>{{domxref("GainNode")}}</li>
 <li>{{domxref("AudioContext")}}</li>
</ul>
